package soma;

/**
 * Classe reprsentant le puzzle
 * 
 * @author xphilippeau
 *
 */
public class Puzzle extends Shape {

	private boolean[] storage = new boolean[1000];
	
	/**
	 * @param data int[N][3] liste des coordonnes des N cubes composant le puzzle
	 */
	public Puzzle(int [][] data) {
		super(data);
		
		// stocke le puzzle sous forme d'un tableau de boolen : 
		// le boolen a l'indice XYZ est a "true" s'il y a un cube aux coordonnes {X,Y,Z}
		for(int cube:this.cubes)
			this.storage[cube]=true;
	}
	
	/**
	 * @param s forme a tester
	 * @return true si la forme est intgralement contenue dans le puzzle
	 */
	public boolean contains(Shape s) {
		for(int cube:s.cubes)
			if (!this.storage[cube]) return false;
		return true;
	}
	
	/**
	 * Supprime la forme du puzzle
	 * @param s la forme a supprimer
	 */
	public void remove(Shape s) {
		for(int cube:s.cubes)
			this.storage[cube]=false;
	}

	/**
	 * Ajoute la forme au puzzle
	 * @param s la forme a ajouter
	 */
	public void add(Shape s) {
		for(int cube:s.cubes)
			this.storage[cube]=true;
	}
	
	/**
	 * @return true si le puzzle est vide
	 */
	public boolean isEmpty() {
		for(boolean b:this.storage)
			if (b) return false;
		return true;
	}	
}
